dnl ----------------- General purpose m4 Macro library ----------------------
dnl (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1995
dnl
dnl see info file .../doc/info/m4macros.nfo (section * macro.m4::)
dnl
dnl
changequote(`{',`}')dnl
dnl
dnl --- m4 Modules ---
define({Provide},{ifdef({$$Provided_$1},,
	{define({$$Provided_$1},{YES})dnl
	$2{}ifdef({VERBOSE},errprint({Provided $1
}))})})dnl
define({Require},{ifdef({$$Provided_$1},,
	{errprint({Requiring $1... })include({$1.m4})dnl})})dnl
define({defdef},{ifdef({$1},,{define({$1},{$2})})})dnl
dnl
Provide({macro},{
dnl
dnl
dnl --- Constants ---
dnl
define({__nl__},{
})dnl
dnl
dnl
dnl --- Argument mangling ---
dnl
define({forget},)dnl
define({nargs},{$#})dnl
define({expand0},$*)dnl
define({expand},{expand0($*)})dnl
define({quote},{{{$*}}})dnl
define({head},{$1})dnl
define({tail},{shift($@)})dnl
define({cat9},{{}$1{}$2{}$3{}$4{}$5{}$6{}$7{}$8{}$9{}})dnl
define({cat},
	{ifelse($#, 0,,
		$#, 1,{$1},
		{format({%s{}%s},{$1},{cat(shift($@))})})})dnl
define({reverse}, {ifelse($#, 0, , $#, 1, {{$1}},
     			  {reverse(shift($@)), {$1}})})dnl
define({accumulate},{accumulate_({$1},$1({$2}))})dnl
define({accumulate_},
	{ifelse({$2},,,{$3},,{$2},
		{{$2},accumulate({$1},{$3})})})dnl
dnl
dnl
dnl --- Character access ---
dnl
define({split_char},{regexp({$1},{\(.\)\(.*\)},{{\1},{\2}})})dnl
define({char_list},{accumulate({split_char},{$1})})dnl
define({reversechars},{cat(reverse(char_list($1)))})dnl
define({upcase},  {translit({$*},{a-z},{A-Z})})dnl
define({downcase},{translit({$*},{A-Z},{a-z})})dnl
dnl
dnl
dnl --- Loops ---
dnl
define({forloop},
	{pushdef({$1}, {$2})_forloop({$1}, {$2}, {$3}, {$4})popdef({$1})})dnl
define({_forloop},
	{$4{}ifelse($1, {$3}, ,
		{define({$1}, incr($1))_forloop({$1}, {$2}, {$3}, {$4})})})dnl
define({rept},
	{ifelse(eval({$1>0}),1,
		{forloop({i},{1},{$1},{$2})})})dnl
define({irp},
{pushdef({$1})dnl
pushdef({_loop_body_$1},{shift(shift($@))})dnl
_irp({$1}, $2){}dnl
popdef({_loop_body_$1})dnl
popdef({$1})})dnl
define({_irp},
	{ifelse($#, 1,,
		$#, 2,{_irp_once({$1},{$2})},
		{_irp_once({$1},{$2}){}_irp({$1},shift(shift($@)))})})dnl
define({_irp_once},
	{define({$1},{$2})expand(_loop_body_$1){}})dnl
dnl
dnl
dnl --- Counters ---
dnl
define({addvar},
	{define({$1},eval($2+$1))})dnl
define({incrvar},
	{define({$1},incr($1))})dnl
define({varadd},
	{cat($1,addvar({$1},{$2}))})dnl
define({varincr},
	{cat($1,incrvar({$1}))})dnl
dnl
dnl
dnl --- min, max ---
dnl
define({max},{ifelse(eval(($1)>($2)),1,$1,$2)})dnl
define({min},{ifelse(eval(($1)<($2)),1,$1,$2)})dnl
dnl
dnl
dnl --- local labels ---
dnl
define({labelprefix},{L})dnl
define({currentlabel},{0})dnl
define({newlabel},{format({%s%04X},labelprefix,varincr({currentlabel}))})dnl
define({local},
	{cat9({pushdef({$1},newlabel)},{$2},{popdef({$1})})})dnl
define({locals},
	{ifelse($#,0,,
		$#,1,{$1},
		{local({$1},{locals(shift($@))})})})dnl
dnl
dnl
dnl --- metastacks ---
dnl
define({__newstk__},
    {define({__sp__$1},0)})dnl
define({__push__},
    {incrvar({__sp__$1})define({__stk__$1__}__sp__$1,{$2})})dnl
define({__pop__},
    {addvar({__sp__$1},-1)})dnl
define({__pick__},
    {indir({__stk__$1__}eval(__sp__$1-ifelse({$2},,0,{$2})))})dnl
dnl
dnl
dnl --- diverting ---
dnl
dnl define({__currentdiversion__},0)dnl
define({__numdiversion__},1)dnl
dnl
define({indiversion},
{cat9(	{pushdef({__currentdiversion__},divnum)},
	{divert($1)},
	{$2},
	{divert(__currentdiversion__)},
	{popdef({__currentdiversion__})})})dnl
dnl
define({declarediversion0},
{define({$1},{indiversion($2,{$3})})})dnl
define({declarediversion},
{declarediversion0({$1},varincr({__numdiversion__}),{$}{*})})dnl
dnl
dnl
dnl --- Error output ---
dnl
define({_OUT_},{errprint($@)})dnl
define({_OUTln_},{errprint($@{}__nl__)})dnl
dnl
dnl
})dnl ------------------------- end of macro.m4 ------------------------------
dnl
dnl
