dnl ----------------------=|=--- debug.m4 ---=|=-----------------------------
dnl --=-- Debugging routines for the i386 --=---
dnl
dnl
dnl Lots of info taken from the sources of the Linux console driver.
dnl
Provide({debug},{
dnl
dnl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Debugging ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pmpart

__stringseg__({


define({NamedDump},{
	.ascii "$1="
	.byte 0,$2,$3})

ERegs_DumpLayout:
	irp(X,{
{EAX,8,3},     {EBX,8,3},     {ECX,8,3},     {EDX,8,5},       {EIP,8,6}, 
{ESI,8,3},     {EDI,8,3},     {EBP,8,3},     {ESP,8,5},       {EFLAGS,8,3},
{CS,4,2}, {DS,4,2}, {ES,4,2}, {FS,4,2}, {GS,4,2}, {SS,4,10},  {ERRNUM,8,3}},
	{NamedDump(X)})


define({DumpDescr},{
	.byte ifelse({$2},{},{sizeof_$1/4},{+ ($2)})
	irp(reg,{EAX,EBX,ECX,EDX,EIP,ESI,EDI,EBP,ESP,EFLAGS,
		CS,DS,ES,FS,GS,SS},{.byte $1_{}reg
})	ifelse($#,1,{},$#,2,{},{.byte shift(shift($@))})})


Struc({INTSTACK_D},{
  irp(reg,
	{ES,DS,FS,GS,
	 EDI,ESI,EBP,aESP,EBX,EDX,ECX,EAX,
	 ERROR,EIP,CS,EFLAGS,ESP,SS},
	{_long_(reg)})
})dnl
Struc({ERegs_D},{
  irp(reg,
	{EDI,ESI,EBP,ESP,EBX,EDX,ECX,EAX,
	 EFLAGS,CS,DS,ES,FS,GS,SS,EIP},
	{_long_(reg)})
})dnl


ERegs_DumpDescr:	DumpDescr({ERegs_D},16)
V86INT_DumpDescr:	DumpDescr({V86INT},16)
INTSTACK_DumpDescr:	DumpDescr({INTSTACK_D},17)


})


__dataseg__({
})

__udataseg__({

DumpLine = alallot(u,4)

})

__codeseg__({



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Subroutines ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sleep_1s:
	STOP(fs,0xB8000,79,1,'1,0x70)
	push ecx
	mov ecx,#0x1000  ;0x80000	; 1 M
 s1s:
	STOP(fs,0xB8000,79,2,'=,0x70)
	pushad
	mov edi,[pmaddr(Video_mem_base)]
	add edi,#(70+2*80)*2
	mov edx,ecx
	mov ecx,#8
	mov ah,#0x07
	call DumpHex
	popad
	STOP(fs,0xB8000,79,2,'+,0x70)
	loop s1s
	pop ecx
	STOP(fs,0xB8000,79,2,'s,0x70)
	ret

sleep:
	pushad
	mov edi,[pmaddr(Video_mem_base)]
	add edi,#(70+80)*2
	mov edx,ecx
	mov ecx,#8
	mov ah,#0x07
	call DumpHex
	popad
	STOP(fs,0xB8000,79,1,'R,0x70)
	call sleep_1s
	STOP(fs,0xB8000,79,1,'Z,0x70)
	call sleep_1s
	loop sleep
	STOP(fs,0xB8000,79,1,'Z,0x07)
	ret



DumpERegs:
	;STOP(fs,0xB8000,75,20,'E,0x07)
   ;;; Push data to dump:
	pushm(ad,fd,cs,ds,es,fs,gs,ss)
	add [esp+ERegs_D_ESP],#sizeof_ERegs_D-sizeof_PUSHAD
	;STOP(fs,0xB8000,76,20,'R,0x07)
   ;;; Use MyDump
	mov esi,#pmaddr(ERegs_DumpLayout)
	mov ebp,#pmaddr(ERegs_DumpDescr)
	mov ebx,esp
	;STOP(fs,0xB8000,77,20,'e,0x07)
	call MyDump
	;STOP(fs,0xB8000,78,20,'g,0x07)
   ;;; Done
	popm(ad,fd,ds,ds,es)
	lea esp,[esp+12] ; do not modify flags !
	;STOP(fs,0xB8000,79,20,'s,0x07)
	ret

DumpV86INT:
	STOP(fs,0xB8000,0,22,'V,0x07)
	pushad
	mov esi,#pmaddr(ERegs_DumpLayout)
	mov ebp,#pmaddr(V86INT_DumpDescr)
	STOP(fs,0xB8000,1,22,'8,0x07)
	call MyDump
	popad
	STOP(fs,0xB8000,2,22,'6,0x07)
	ret

DumpINTSTACK:
	mov esi,#pmaddr(ERegs_DumpLayout)
	mov ebp,#pmaddr(INTSTACK_DumpDescr)
	mov ebx,esp
	call MyDump
	ret

;;;;; Dump some commented data to screen
MyDump:
; esi: a layout table
; ebp: a dump parameter description table
; ebx: parameter
	;STOP(fs,0xB8000,0,21,'M,0x07)
   ;;; Setup Segments Registers
	push #PMPARTDS
	pop ds
	push ds
	pop es
	cld
	;STOP(fs,0xB8000,1,21,'S,0x07)
   ;;; Point to the current screen lines to output to
	mov edi,[pmaddr(Video_mem_base)]
	STOP(fs,0xB8000,2,21,'V,0x0F)
	STOP(ds,edi,    2,21,'V,0x07)
	mov eax,#80*2
	mul dword [pmaddr(DumpLine)]
	add [pmaddr(DumpLine)],3
	add edi,eax
	;STOP(fs,0xB8000,3,21,'B,0x07)
   ;;; Loop
	mov ah,#0x07		; video attribute
	movzx ecx,byte [ebp]	; number of values to show
	inc ebp
	;STOP(fs,0xB8000,4,21,'0,0x07)
Loopno0({pushing({ecx},{
	;STOP(fs,0xB8000,5,21,'L,0x07)
     ;;; Show Texts
	call DumpString
	;STOP(fs,0xB8000,6,21,'S,0x07)
     ;;; Show Hex Number
	movzx ecx,byte [ebp]	; offset of the value to show
	inc ebp
	mov edx,[ebx+ecx]	; value to show
	pushing({ecx},{
	  lodsb			; number of digits for the value
	  mov cl,al		; (high of ecx zeroed above)
	  call DumpHex
	})
	;STOP(fs,0xB8000,7,21,'H,0x07)
     ;;; Show spaces
	__IF__(necxz)
	  lodsb
	  mov cl,al
	__THEN__
	  mov al,#0x20
	  rep
	  stosw
	__ENDIF__
	;STOP(fs,0xB8000,8,21,'S,0x07)
	})
})
	;STOP(fs,0xB8000,8,21,'P,0x07)
	ret
;DumpRoutineTable:
;	.long	0,DumpWord,DumpLong


DumpString0:
	stosw
DumpString:
;; Dumps a 0-terminated string on screen, with attribute being ah.
	lodsb
	setf(al)
	jnz DumpString0
	ret

DumpZone:
;; print hex numbers in a zone
;; edx: byte intervals between numbers
;; ecx: number of numbers to show
;; esi: first number to show in the zone
;; edi: position in video buffer in which to show
;; spaces are printed, ah is the attribute
	pushing({ecx},{
	  mov ecx,ebx
	  pushing(edx,{
	    mov edx,[esi]
	    mov ecx,8
	    call DumpHex
	  })
	  add esi,edx
	})
	dec ecx
	Loop({pushing({ecx},{
	  mov al,#0x20
	  stosw
	  mov ecx,ebx
	  pushing(edx,{
	    mov edx,[esi]
	    mov ecx,8
	    call DumpHex
	  })
	  add esi,edx
	})})
	ret

DumpERegs0:
   ;;; Push data to dump:
	pushm(ad,fd,cs,ds,es,fs,gs,ss)
	push #PMPARTDS
	pop ds
	push ds
	pop es
   ;;; First series:
	mov ecx,16
	mov ebp,esp
	mov ah,#0x07
	mov edi,[pmaddr(Video_mem_base)]
	mov eax,#80*2
	mul dword [pmaddr(DumpLine)]
	add [pmaddr(DumpLine)],3
	add edi,eax
	mov ah,#0x07
	Loopno0({pushing(ecx,{
	  mov edx,[ebp]
	  mov ecx,8
	  call DumpHex
	  mov eax,#0x07200720
	  stosd
	  add ebp,4
	})})
   ;;; Done
	popm(ad,fd) ! [fs,gs,ss not loaded]
	lea esp,[esp+4]
	popm(ds,es)
	lea esp,[esp+12] ; do not modify flags
	ret
})
dnl
dnl
})dnl --- debug.m4
dnl
