dnl ------------------- header.m4 -------------------
dnl Header of the TUNES API object file
dnl
dnl
dnl
Provide({header},{
dnl
Require(as86)dnl
Require(i386)dnl
dnl
dnl
dnl
dnl ----------- Define the generic header -----------
dnl
;Signature
;; The first 32 bytes are reserved for the signature
;; The first 20 bytes may be searched for to find the API.
;; The 12 remaining bytes may be used for version identification.

  .org APIOFS
   MagicNumber:		.long	API_MAGIC

  .org APIOFS+4
   Signature:		defb(API_NAME,0)

  .org APIOFS+28
   version_major:	.byte	MAJOR_VERSION
   version_minor:	.byte	MINOR_VERSION
   version_patchlevel:	.byte	PATCH_LEVEL
   version_internal:	.byte	INTERNAL_REVISION



;; After the signature, system fields
  .org APIOFS+32

   API_Header:
	.long	APISIZE
	.long	API_Entry_Point
	.long	APIOFS
	.long	0
	.long	0,0,0,0

dnl --------- Here is what a Linux header should be ----------

forget({

aoutmagic:	.word QMAGIC		dnl impure executable
aoutcpu:	.byte 100		dnl Linux/i386
aoutflags:	.byte 00		dnl 0

dnl all sizes in bytes...
a_text:		.long textsize		dnl length of text
a_data:		.long datasize		dnl length of data
a_bss:		.long bsssize		dnl length of uninitialized
					dnl data area for file
a_syms:		.long symssize		dnl length of symbol table data in file
a_entry:	.long entry		dnl start address
a_trsize:	.long 0			dnl length of relocation info for text
a_drsize:	.long 0			dnl length of relocation info for data


})

})dnl --- end of header.m4
dnl
